/*
 * EditBufferFind.h
 *
 * Searching for a string in the buffer
 * 
 * Author: Ferenc Moricz
 * $Revision: 1.5 $
 * $Date: 2003/06/26 22:01:28 $
 *
 */
 
#ifndef EDITBUFFERFIND
#define EDITBUFFERFIND

#include "EditBuffer.h"

#include <qpushbutton.h>
#include <qdialog.h>

class EditBufferFind : public QHBox
{
Q_OBJECT
  public:
	QWidget *pWidget;

	EditBufferFind( EditBufferText *, QWidget * );
	~EditBufferFind();
	void findClose(void);
	void find( const QString &, int);
	bool eventFilter( QObject * pWatchedObject, QEvent *pEvent );

  protected:
	EditBufferText *buffer;

	QWidget *pParent;
	QDialog *pDialog;

	QLineEdit *pSearchText, *pReplaceText;
	const QPalette *palette;
	QPalette *paletteerror;

	QPushButton *pUpButton, *pMoreButton, *pReplaceButton;
	static bool eFindBottom;
	void gotoPlace(bool eFindBottom );

	QPoint selectB, selectE;
	const QColor *selectcolor;
	int firstVisible;
	QPoint cursor;

	bool bFound, bNoSearch;

	bool returnEvent();
	bool escEvent();
	void pageEvent( int );

  public slots:
	void findCB( const QString & );
	void upButtonEvent( void );
	void moreButtonEvent( void );
	void replaceButtonEvent( void );
};

#endif

