/*
 * EditLine.h
 *
 * A text line
 * 
 * Author: Ferenc Moricz
 * $Revision: 1.18 $
 * $Date: 2003/12/29 03:45:34 $
 *
 */
 
#ifndef EDITLINE
#define EDITLINE

#include <qstring.h>

class EditLine : public QString 
{
  public:
	EditLine( const QString & );
//	int doWrap( int columns, QList<QString> *result );

	int tabbedPosition( int, int = -1, bool = true );
	static int tabbedPosition( QString &, int, int = -1, bool = true );
	int nontabbedPosition( int, int = -1 );
	static int nontabbedPosition( QString &, int, int = -1 );

	inline const char *midbegin( int at, int length = 0xffffffff )
		{ return mid( at, length); }
	inline void midend() {}
	int gotoWord(int iPos=0, bool bRight=true, bool bWordEndAlso=true, bool bSplitAtSign=true);

	void appendString( unsigned char *sStr, bool bUTF8 = false );
	EditLine *splitLine( int iPosition, int iSize );

	int forward;

	static bool canBeUTF8(unsigned char *sStr);

  protected:
	int lines;
};

#endif
