/*
 * EditLineSyntax.h
 *
 * Syntax highlighting
 *
 * Author: Ferenc Moricz
 * $Revision: 1.6 $
 * $Date: 2003/08/11 23:14:10 $
 *
 */

#ifndef EDITLINESYNTAX
#define EDITLINESYNTAX

#include "EditLine.h"
#include <qregexp.h>
#include <qcolor.h>

class SyntaxRule
{
  public:
	SyntaxRule( char *, char *, char * = NULL );

	QRegExp *begstring, *endstring;
	QString *name;
};

class EditLineSyntax
{
  public:
	EditLineSyntax();
	void setText( QString *, int = -1, bool = true );
	bool next();

	inline QString *getType() { return type; }
	inline QString *getText() { return string; }
	int getPosition() { return iPosition; }
	inline int getLength() { return length; }
	inline int getForward() { return forward; }

  protected:
	static vector<SyntaxRule *, allocator<SyntaxRule *> > *pRules;
	static vector<int *, allocator<int *> > *pHits;
	QString *string, *type;
	int length, iPosition;
	int forward;
	bool bSyntaxHighlighting;
};

#endif
