/*
 * console_window - declarations
 *
 * Console window module for Freddy
 * 
 * Author: Ferenc Moricz
 * Date:   2001/12/21
 * $Revision: 1.4 $
 *
 */

#ifndef CONSOLE_WINDOW_H
#define CONSOLE_WINDOW_H

//#include <stdio.h>

#include <qlabel.h>
#include <qlineedit.h>
#include <qptrlist.h>
#include <qmultilineedit.h>
#include <qobject.h>
#include <qstring.h>
#include <qvbox.h>

#include "Module.h"

extern "C" MODULES_API QString *module_function(Module *pModule, const QString &qsFunction,
            QString *qsParam1, QString *qsParam2, int iParam1, int iParam2);

extern "C" MODULES_API Module *module_init(Module *pModule);

class console_feeder : public QObject
{
Q_OBJECT

  public:
	FILE *pipe_fp;
	bool running;

  public slots:
	void pthread_slot( void );

  protected:
	void processLine(QString &line);
	QString linebuffer;
};

class ConsoleText : public QMultiLineEdit
{
Q_OBJECT

  public:
	ConsoleText( QWidget *parent );
	int errorline;
	QList<QString> dirs;

  protected:
	int cursorline;

  public slots:
	void cursorMoved( int y, int x );
	void doubleClickEvent( int iPar, int iCol );
};

class ConsoleWindow : public QVBox
{
Q_OBJECT

  public:
	/* constructor */
	ConsoleWindow( QWidget *parent );

	/* text area functions */
	inline ConsoleText *text() { return multiline; }
	QLineEdit *getsymbol, *getpath;

	/* status ball */
	char **changePixTextColors( const char *sPixText[], float fRed, float fGreen, float fBlue );
	void purgePixText( char *sPixText[] );
	void displayCurrentPixmap( bool bRepaint = false );
	void updateToolTip( void );

	QLabel *pStatusSigner;
	QPixmap *pSignPix[3][4];
	int iSignSpinning, iCompileState;
	int iCompileNumWarn, iCompileNumErr;
	QTimer *pSignTimer;

  public slots:
	void signTimeout();

  protected:
	ConsoleText *multiline;
};

#endif

