/**
 * @file ctags.h
 * ETAGS/CTAGS module for Freddy
 *
 * @author Ferenc Moricz
 * Created:   2001/05/16
 *
 * $Revision: 1.2 $
 * $Date: 2003/04/02 23:07:39 $
 *
 */

#include "Module.h"
#include "EditBuffer.h"

#include <qcache.h>
#include <qfile.h>
#include <qptrlist.h>
#include <qdir.h>

#include <qdialog.h>
#include <qwhatsthis.h>

extern "C" QString *module_function(Module *pModule, const QString &qsFunction,
                      QString *qsParam1, QString *qsParam2, int iParam1, int iParam2);

extern "C" Module *module_init(Module *pModule);

class ETags_CTagsTag
{
  public:
	QString *name;
	QString *path;
	QString *mask;
	char kind;
	int line;
	QString *what;
};

class ETags_TaggedFile
{
  public:
	ETags_TaggedFile() { abspath = path = NULL; }

	QString *abspath;
	QString *path;
	QList<ETags_CTagsTag> tags;
};

class ETags_TaggedFileDict : public QDict< QList<ETags_TaggedFile> >
{
  public:
	ETags_TaggedFileDict();
	ETags_TaggedFile *searchFile(QString *which, bool create = true);
};

void ETags_create(Module *pMapBar, EditBuffer *pBuffer);

class ETags_CTags : public QDict< QList<ETags_CTagsTag> >
{
  public:
	ETags_CTags(QFile *file = NULL);
	QDir *ctagdir;

	QFile *file;

	void loadCTagsFile( QString &sFileName );
};

class ETags_DisplayText : public QDialog
{
  public:
	ETags_DisplayText(QString *text, QWidget *parent);
	virtual QSize sizeHint() const;
  protected:
	virtual bool event(QEvent *);
	QString *text;
	virtual void paintEvent(QPaintEvent *);
};

